package server

import (
	"context"
	"github.com/odysseus/nodemanager/config"
	odysseus "github.com/odysseus/odysseus-protocol/gen/proto/go/base/v1"
	"strconv"
)

func (wm *WorkerManager) AddWorker(worker *Worker) {
	for _, device := range worker.deviceInfo {
		// add device to redis
		priority := 0
		_ = device // todo: set priority with device info.
		if err := wm.rdb.LPush(context.Background(), config.WORKER_QUEUE_PREFIX+strconv.Itoa(priority), worker.uuid).Err(); err != nil {
			continue
		}
	}
	// add worker to redis queue
	wm.rdb.Set(context.Background(), config.WORKER_STATUS_PREFIX+strconv.FormatInt(worker.uuid, 10), odysseus.WorkerStatus_WorkerStatusActive, 0)
}

func (wm *WorkerManager) ActiveWorker(worker *Worker) {
	wm.rdb.Set(context.Background(), config.WORKER_STATUS_PREFIX+strconv.FormatInt(worker.uuid, 10), odysseus.WorkerStatus_WorkerStatusActive, 0)
}

func (wm *WorkerManager) InActiveWorker(worker *Worker) {
	wm.rdb.Set(context.Background(), config.WORKER_STATUS_PREFIX+strconv.FormatInt(worker.uuid, 10), odysseus.WorkerStatus_WorkerStatusInActive, 0)
}
